<template>
  <div>
    <li>
      <a
        class="kioskbutton"
        data-control="PopupTrigger"
        @click.prevent="$refs.likeModal.Open(); voteUIControls($refs);"><img src="/images/kiosk-button6-like.png"></a>
    </li>
    <like-modal ref="likeModal">
      <div
        id="overlay"
        slot="like">
        <section
          id="likewindow"
          style="display: block; "
          data-control="Popup"
          class="modalwindow">
          <div class="windowcontent">
            <p>Likes</p>
            <ul
              v-show="!completedVote"
              class="likecheckul">
              <li
                :class="{likeactive: completedQuestion1 === true }"
                class="likeli1">Product
              </li>
              <li
                :class="{likeactive: completedQuestion2 === true }"
                class="likeli2">Customer Service
              </li>
              <li
                :class="{likeactive: completedQuestion3 === true }"
                class="likeli3">Advertisement
              </li>
              <li
                :class="{likeactive: completedQuestion4 === true }"
                class="likeli4">Shop Name
              </li>
            </ul>
            <div v-show="!finishedBallot && !completedVote">
              <p
                v-show="question1"
                class="likequestion clear">Which shop had the best product?
              </p>
              <p
                v-show="question2"
                class="likequestion clear">Which shop had the best customer service?
              </p>
              <p
                v-show="question3"
                class="likequestion clear">Which shop had the best advertisement?
              </p>
              <p
                v-show="question4"
                class="likequestion clear">Which shop had the best shop name?
              </p>
              <div class="surveyanswercontainer">
                <!-- should try to restyle this in select/option format -->
                <div class="selectoptionscontainer">
                  <!-- <ul class="selectoptions">
                    <li
                      v-for="(shop, index) in shops"
                      :key="index"
                      :value="shop.account">{{shop.name}}
                    </li>
                  </ul> -->
                  <!-- unstyled, but refactor approach needs style -->
                  <transition name="expand">
                    <div
                      v-show="showLikesValidation"
                      class="errors">
                      <p>
                        You must make a selection.
                      </p>
                    </div>
                  </transition>
                  <select v-model="vote.shop_account_id">
                    <option
                      disabled
                      selected
                      value="Please Select One...">Please Select One...
                    </option>
                    <option
                      v-for="(shop, index) in shops"
                      :key="index"
                      :value="shop.account">{{ shop.name }}
                    </option>
                  </select>
                </div>
                <div class="popupbuttoncontainer likebutton">
                  <div class="popupbtn buttonleft"/>
                  <div
                    v-if="uiTracking < 4"
                    class="popupbtn buttonmiddle"
                    @click="voteUIControls($refs)">Next
                  </div>
                  <div
                    v-else
                    class="popupbtn buttonmiddle"
                    @click="voteUIControls($refs)">Done
                  </div>
                  <div class="popupbtn buttonright"/>
                  <div class="clear"/>
                </div>
                <div class="clear"/>
              </div>
            </div>
            <div
              v-show="finishedBallot || completedVote"
              style="display: block;"
              class="submitted">
              <br>Thank You!<br>Your votes have been submitted.
              <div class="popupbuttoncontainer close">
                <div class="popupbtn buttonleft"/>
                <div
                  class="popupbtn buttonmiddle"
                  @click="resetModal($refs)">Close
                </div>
                <div class="popupbtn buttonright"/>
                <div class="clear"/>
              </div>
            </div>
          </div>
          <a
            class="close closebutton maskfadeout"
            data-dismiss="modal"
            @click="resetModal($refs)"><img src="/images/closebutton.png"></a>
        </section>
      </div>
    </like-modal>
  </div>
</template>

<script>
import LikeModal from "../../../shared/views/ShopModal.vue";
export default {
  components: {
    LikeModal
  },
  props: {
    accountId: Number,
    session: Number,
    completedVote: Boolean
  },
  data() {
    return {
      shops: [],
      question1: false,
      completedQuestion1: false,
      question2: false,
      completedQuestion2: false,
      question3: false,
      completedQuestion3: false,
      question4: false,
      completedQuestion4: false,
      finishedBallot: false,
      uiTracking: 0,
      vote: {
        shop_account_id: "Please Select One...",
        like_categories: null
      },
      ballot: [],
      showLikesValidation: false
    };
  },
  beforeMount: function () {
    this.getShops();
  },
  methods: {
    getShops() {
      app.session.SetSession()
        .then( () => {
        app.api.Get( "/economies/getAllWithAccountIds/" + app.session.data.id)
          .then( Response => {
            Response.forEach(shop => {
              this.shops.push({name: shop.pretty_name, account: shop.accountId});
            });
          })
          .catch( x => app.Message( x.error, "error" ) );
        });
    },
    voteUIControls(ref) {
      const originalVoteState = {
        shop_account_id: "Please Select One...",
        like_categories: null
      };
      // this lets the start up state work as built, and validates on every other question choice
      if(this.uiTracking === 0) {
        this.uiTracking = 1;
      } else {
        if(this.likeVoteValidation()) {
          this.uiTracking += 1;
          this.ballot.push(this.vote);
        } else {
          // reset validation div
          var self = this;
          setTimeout(function() {
            self.showLikesValidation = false;
          }, 2000);
        }
      }
      if (this.uiTracking === 1) {
        this.question1 = true;
        this.vote.session = this.session;
        this.vote.individual_account_id = this.accountId;
        this.vote.like_categories = "product";
      } else if (this.uiTracking === 2) {
        this.completedQuestion1 = true;
        this.vote = originalVoteState;
        this.vote.session = this.session;
        this.vote.individual_account_id = this.accountId;
        this.vote.like_categories = "customer_service";
        this.question1 = false;
        this.question2 = true;
      } else if (this.uiTracking === 3) {
        this.completedQuestion2 = true;
        this.vote = originalVoteState;
        this.vote.session = this.session;
        this.vote.individual_account_id = this.accountId;
        this.vote.like_categories = "advertisement";
        this.question2 = false;
        this.question3 = true;
      } else if (this.uiTracking === 4) {
        this.completedQuestion3 = true;
        this.vote = originalVoteState;
        this.vote.session = this.session;
        this.vote.individual_account_id = this.accountId;
        this.vote.like_categories = "shop_name";
        this.question3 = false;
        this.question4 = true;
      } else if (this.uiTracking === 5) {
        this.completedQuestion4 = true;
        this.finishedBallot = true;
        this.vote = originalVoteState;
        this.question4 = false;
        this.postBallot(ref);
      }
    },
    postBallot(ref) {
      const data = {ballot: this.ballot};
      console.log(data);
      app.api.Post("likes/", data)
        .then( Response => {
          console.log(Response);
          this.$emit("refresh-account");
          setTimeout(() => {
            this.resetModal(ref);
            this.finishedBallot = false;
          }, 3000);
        })
        .catch( x => app.Message( x.error, "error" ));
    },
    resetModal(ref) {
      this.ballot = [];
      this.completedQuestion1 = false;
      this.question1 = false;
      this.completedQuestion2 = false;
      this.question2 = false;
      this.completedQuestion3 = false;
      this.question3 = false;
      this.completedQuestion4 = false;
      this.question4 = false;
      this.uiTracking = 0;
      ref.likeModal.Close();
    },
    likeVoteValidation() {
      if(this.vote.shop_account_id === "Please Select One..." || this.vote.shop_account_id === 0){
        this.showLikesValidation = true;
        return false;
      } else {
        return true;
      }
    }
  },

};
</script>

<style>
/* always present */
.expand-transition {
  transition: all .3s ease;
  height: 30px;
  padding: 10px;
  background-color: #eee;
  overflow: hidden;
}
/* .expand-enter defines the starting state for entering */
/* .expand-leave defines the ending state for leaving */
.expand-enter, .expand-leave {
  height: 0;
  padding: 0 10px;
  opacity: 0;
}

div.errors {
    margin: 0 auto;
    list-style: none;
    font-family: "Mouse Memoirs";
    font-size: 24px;
    line-height: 1.1em;
    color: white;
}

div.errors p {
    -moz-box-sizing: border-box;
    box-sizing: border-box;
    padding-left: 110px;
    padding-right: 20px;
    padding-bottom: 14px;
    background: rgba(255, 0, 0, .5);
    border-left: 3px solid red;
    border-right: 3px solid red;
    color: white !important;
    position: relative;
    text-indent: -8px;
}

div.errors p:before {
    content: "";
    display: block;
    position: relative;
    float: left;
    top: 9px;
    left: -17px;
    width: 8px;
    height: 8px;
    background: white;
    border-radius: 10px;
}

div.errors p:first-of-type {
    border-top-left-radius: 10px;
    border-top-right-radius: 10px;
    border-top: 3px solid red;
    background-position: 20px 10px;
    background-repeat: no-repeat;
    padding-top: 20px;
    margin-top: 30px;
}

div.errors p:last-of-type {
    border-bottom-left-radius: 10px;
    border-bottom-right-radius: 10px;
    border-bottom: 3px solid red;
    padding-bottom: 20px;
    margin-bottom: 10px;
}
</style>